diff --git a/src/rc/checkpath.c b/src/rc/checkpath.c
index 448c9cf81..f19d96a28 100644
--- a/src/rc/checkpath.c
+++ b/src/rc/checkpath.c
@@ -23,6 +23,7 @@
 #include <fcntl.h>
 #include <getopt.h>
 #include <grp.h>
+#include <libgen.h>
 #include <pwd.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -69,10 +70,63 @@ const char * const longopts_help[] = {
 };
 const char *usagestring = NULL;
 
+static int get_dirfd(char *path) {
+	char *path_dupe;
+	char *dir;
+	int dirfd;
+	char *msg = NULL;
+	char *item;
+	int new_dirfd;
+	struct stat st;
+
+	if (!path || *path != '/')
+		eerrorx("checkpath: null or relative path\n");
+	path_dupe = xstrdup(path);
+	dir = xstrdup(dirname(path_dupe));
+	dirfd = openat(dirfd, "/", O_RDONLY);
+	if (dirfd == -1)
+		xasprintf(&msg, "checkpath: unable to open the root directory: %s",
+				strerror(errno));
+	if (!msg)
+		item = strtok(dir, "/");
+	while (!msg && dirfd > 0 && item) {
+		new_dirfd = openat(dirfd, item, O_RDONLY);
+		if (new_dirfd == -1) {
+			xasprintf(&msg, "checkpath: %s: unable to open %s: %s", path, item,
+					strerror(errno));
+			close(new_dirfd);
+			continue;
+		}
+		if (fstat(new_dirfd, &st) == -1) {
+			xasprintf(&msg, "checkpath: %s: unable to stat %s: %s", path, item,
+					strerror(errno));
+			close(new_dirfd);
+			continue;
+		}
+		if (S_ISLNK(st.st_mode) && st.st_uid != 0) {
+			xasprintf(&msg,
+					"checkpath: %s: non-terminal symlink %s not owned by root",
+					path, item);
+			close(new_dirfd);
+			continue;
+		}
+		close(dirfd);
+		dirfd = new_dirfd;
+		item = strtok(NULL, "/");
+	}
+	free(dir);
+	free(path_dupe);
+	if (msg)
+		eerrorx("%s\n", msg);
+	return dirfd;
+}
+
 static int do_check(char *path, uid_t uid, gid_t gid, mode_t mode,
 	inode_t type, bool trunc, bool chowner, bool selinux_on)
 {
 	struct stat st;
+	char *name = NULL;
+	int dirfd;
 	int fd;
 	int flags;
 	int r;
@@ -93,14 +147,16 @@ static int do_check(char *path, uid_t uid, gid_t gid, mode_t mode,
 #endif
 	if (trunc)
 		flags |= O_TRUNC;
-	readfd = open(path, readflags);
+	xasprintf(&name, "%s", basename_c(path));
+	dirfd = get_dirfd(path);
+	readfd = openat(dirfd, name, readflags);
 	if (readfd == -1 || (type == inode_file && trunc)) {
 		if (type == inode_file) {
 			einfo("%s: creating file", path);
 			if (!mode) /* 664 */
 				mode = S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP | S_IROTH;
 			u = umask(0);
-			fd = open(path, flags, mode);
+			fd = openat(dirfd, name, flags, mode);
 			umask(u);
 			if (fd == -1) {
 				eerror("%s: open: %s", applet, strerror(errno));
@@ -122,7 +178,7 @@ static int do_check(char *path, uid_t uid, gid_t gid, mode_t mode,
 				    strerror (errno));
 				return -1;
 			}
-			readfd = open(path, readflags);
+			readfd = openat(dirfd, name, readflags);
 			if (readfd == -1) {
 				eerror("%s: unable to open directory: %s", applet,
 						strerror(errno));
@@ -140,7 +196,7 @@ static int do_check(char *path, uid_t uid, gid_t gid, mode_t mode,
 				    strerror (errno));
 				return -1;
 			}
-			readfd = open(path, readflags);
+			readfd = openat(dirfd, name, readflags);
 			if (readfd == -1) {
 				eerror("%s: unable to open fifo: %s", applet,
 						strerror(errno));
